'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;
  var template = _ref.template;

  // constants used when statically verifying types
  var TYPE_INVALID = 0;
  var TYPE_VALID = 1;
  var TYPE_UNKNOWN = 2;

  /**
   * Binary Operators that can only produce boolean results.
   */
  var BOOLEAN_BINARY_OPERATORS = ['==', '===', '>=', '<=', '>', '<', 'instanceof'];

  var checks = createChecks();
  var staticChecks = createStaticChecks();

  var checkIsArray = template('Array.isArray(input)');

  if (!(typeof checkIsArray === 'function')) {
    throw new TypeError('Value of variable "checkIsArray" violates contract, expected () => Node got ' + (checkIsArray === null ? 'null' : (typeof checkIsArray === 'undefined' ? 'undefined' : _typeof(checkIsArray)) === 'object' && checkIsArray.constructor ? checkIsArray.constructor.name || '[Unknown Object]' : typeof checkIsArray === 'undefined' ? 'undefined' : _typeof(checkIsArray)));
  }

  var checkIsMap = template('input instanceof Map');

  if (!(typeof checkIsMap === 'function')) {
    throw new TypeError('Value of variable "checkIsMap" violates contract, expected () => Node got ' + (checkIsMap === null ? 'null' : (typeof checkIsMap === 'undefined' ? 'undefined' : _typeof(checkIsMap)) === 'object' && checkIsMap.constructor ? checkIsMap.constructor.name || '[Unknown Object]' : typeof checkIsMap === 'undefined' ? 'undefined' : _typeof(checkIsMap)));
  }

  var checkIsSet = template('input instanceof Set');

  if (!(typeof checkIsSet === 'function')) {
    throw new TypeError('Value of variable "checkIsSet" violates contract, expected () => Node got ' + (checkIsSet === null ? 'null' : (typeof checkIsSet === 'undefined' ? 'undefined' : _typeof(checkIsSet)) === 'object' && checkIsSet.constructor ? checkIsSet.constructor.name || '[Unknown Object]' : typeof checkIsSet === 'undefined' ? 'undefined' : _typeof(checkIsSet)));
  }

  var checkIsObject = template('input != null && typeof input === \'object\'');

  if (!(typeof checkIsObject === 'function')) {
    throw new TypeError('Value of variable "checkIsObject" violates contract, expected () => Node got ' + (checkIsObject === null ? 'null' : (typeof checkIsObject === 'undefined' ? 'undefined' : _typeof(checkIsObject)) === 'object' && checkIsObject.constructor ? checkIsObject.constructor.name || '[Unknown Object]' : typeof checkIsObject === 'undefined' ? 'undefined' : _typeof(checkIsObject)));
  }

  var checkNotNull = template('input != null');

  if (!(typeof checkNotNull === 'function')) {
    throw new TypeError('Value of variable "checkNotNull" violates contract, expected () => Node got ' + (checkNotNull === null ? 'null' : (typeof checkNotNull === 'undefined' ? 'undefined' : _typeof(checkNotNull)) === 'object' && checkNotNull.constructor ? checkNotNull.constructor.name || '[Unknown Object]' : typeof checkNotNull === 'undefined' ? 'undefined' : _typeof(checkNotNull)));
  }

  var declareTypeChecker = template('\n    const id = function id (input) {\n      return check;\n    };\n  ');

  if (!(typeof declareTypeChecker === 'function')) {
    throw new TypeError('Value of variable "declareTypeChecker" violates contract, expected () => Node got ' + (declareTypeChecker === null ? 'null' : (typeof declareTypeChecker === 'undefined' ? 'undefined' : _typeof(declareTypeChecker)) === 'object' && declareTypeChecker.constructor ? declareTypeChecker.constructor.name || '[Unknown Object]' : typeof declareTypeChecker === 'undefined' ? 'undefined' : _typeof(declareTypeChecker)));
  }

  var guard = template('\n    if (!check) {\n      throw new TypeError(message);\n    }\n  ');

  if (!(typeof guard === 'function')) {
    throw new TypeError('Value of variable "guard" violates contract, expected () => Node got ' + (guard === null ? 'null' : (typeof guard === 'undefined' ? 'undefined' : _typeof(guard)) === 'object' && guard.constructor ? guard.constructor.name || '[Unknown Object]' : typeof guard === 'undefined' ? 'undefined' : _typeof(guard)));
  }

  var thrower = template('\n    if (check) {\n      ret;\n    }\n    else {\n      throw new TypeError(message);\n    }\n  ');

  if (!(typeof thrower === 'function')) {
    throw new TypeError('Value of variable "thrower" violates contract, expected () => Node got ' + (thrower === null ? 'null' : (typeof thrower === 'undefined' ? 'undefined' : _typeof(thrower)) === 'object' && thrower.constructor ? thrower.constructor.name || '[Unknown Object]' : typeof thrower === 'undefined' ? 'undefined' : _typeof(thrower)));
  }

  var readableName = template('\n    input === null ? \'null\' : typeof input === \'object\' && input.constructor ? input.constructor.name || \'[Unknown Object]\' : typeof input\n  ');

  if (!(typeof readableName === 'function')) {
    throw new TypeError('Value of variable "readableName" violates contract, expected () => Node got ' + (readableName === null ? 'null' : (typeof readableName === 'undefined' ? 'undefined' : _typeof(readableName)) === 'object' && readableName.constructor ? readableName.constructor.name || '[Unknown Object]' : typeof readableName === 'undefined' ? 'undefined' : _typeof(readableName)));
  }

  var checkMapKeys = template('\n    input instanceof Map && Array.from(input.keys()).every(key => keyCheck)\n  ');

  if (!(typeof checkMapKeys === 'function')) {
    throw new TypeError('Value of variable "checkMapKeys" violates contract, expected () => Node got ' + (checkMapKeys === null ? 'null' : (typeof checkMapKeys === 'undefined' ? 'undefined' : _typeof(checkMapKeys)) === 'object' && checkMapKeys.constructor ? checkMapKeys.constructor.name || '[Unknown Object]' : typeof checkMapKeys === 'undefined' ? 'undefined' : _typeof(checkMapKeys)));
  }

  var checkMapValues = template('\n    input instanceof Map && Array.from(input.values()).every(value => valueCheck)\n  ');

  if (!(typeof checkMapValues === 'function')) {
    throw new TypeError('Value of variable "checkMapValues" violates contract, expected () => Node got ' + (checkMapValues === null ? 'null' : (typeof checkMapValues === 'undefined' ? 'undefined' : _typeof(checkMapValues)) === 'object' && checkMapValues.constructor ? checkMapValues.constructor.name || '[Unknown Object]' : typeof checkMapValues === 'undefined' ? 'undefined' : _typeof(checkMapValues)));
  }

  var checkMapEntries = template('\n    input instanceof Map && Array.from(input).every(([key, value]) => keyCheck && valueCheck)\n  ');

  if (!(typeof checkMapEntries === 'function')) {
    throw new TypeError('Value of variable "checkMapEntries" violates contract, expected () => Node got ' + (checkMapEntries === null ? 'null' : (typeof checkMapEntries === 'undefined' ? 'undefined' : _typeof(checkMapEntries)) === 'object' && checkMapEntries.constructor ? checkMapEntries.constructor.name || '[Unknown Object]' : typeof checkMapEntries === 'undefined' ? 'undefined' : _typeof(checkMapEntries)));
  }

  var checkSetEntries = template('\n    input instanceof Set && Array.from(input).every(value => valueCheck)\n  ');

  if (!(typeof checkSetEntries === 'function')) {
    throw new TypeError('Value of variable "checkSetEntries" violates contract, expected () => Node got ' + (checkSetEntries === null ? 'null' : (typeof checkSetEntries === 'undefined' ? 'undefined' : _typeof(checkSetEntries)) === 'object' && checkSetEntries.constructor ? checkSetEntries.constructor.name || '[Unknown Object]' : typeof checkSetEntries === 'undefined' ? 'undefined' : _typeof(checkSetEntries)));
  }

  var stack = [];

  return {
    inherits: require("babel-plugin-syntax-flow"),
    visitor: {
      TypeAlias: function TypeAlias(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        path.replaceWith(createTypeAliasChecks(path));
      },
      InterfaceDeclaration: function InterfaceDeclaration(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        path.replaceWith(createInterfaceChecks(path));
      },
      ExportNamedDeclaration: function ExportNamedDeclaration(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;
        var scope = path.scope;

        if (node.declaration.type === 'TypeAlias') {
          path.replaceWith(t.exportNamedDeclaration(createTypeAliasChecks(path.get('declaration')), [], null));
        }
      },
      ImportDeclaration: function ImportDeclaration(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        if (path.node.importKind !== 'type') {
          return;
        }

        var _path$get$map$reduce = path.get('specifiers').map(function (specifier) {
          var local = specifier.get('local');
          var tmpId = path.scope.generateUidIdentifierBasedOnNode(local.node);
          var replacement = t.importSpecifier(tmpId, specifier.node.imported);
          var id = t.identifier(local.node.name);

          id.isTypeChecker = true;
          var declarator = t.variableDeclarator(id, tmpId);
          declarator.isTypeChecker = true;
          return [declarator, replacement];
        }).reduce(function (_ref2, _ref3) {
          var _ref5 = _slicedToArray(_ref2, 2);

          var declarators = _ref5[0];
          var specifiers = _ref5[1];

          var _ref4 = _slicedToArray(_ref3, 2);

          var declarator = _ref4[0];
          var specifier = _ref4[1];

          declarators.push(declarator);
          specifiers.push(specifier);
          return [declarators, specifiers];
        }, [[], []]);

        var _path$get$map$reduce2 = _slicedToArray(_path$get$map$reduce, 2);

        var declarators = _path$get$map$reduce2[0];
        var specifiers = _path$get$map$reduce2[1];

        var declaration = t.variableDeclaration('var', declarators);
        declaration.isTypeChecker = true;

        path.replaceWithMultiple([t.importDeclaration(specifiers, path.node.source), declaration]);
      },

      Function: {
        enter: function enter(path) {
          var _node$body$body;

          if (!NodePath(path)) {
            throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
          }

          var node = path.node;
          var scope = path.scope;

          var paramChecks = collectParamChecks(path);
          if (node.type === "ArrowFunctionExpression" && node.expression) {
            node.expression = false;
            node.body = t.blockStatement([t.returnStatement(node.body)]);
          }
          (_node$body$body = node.body.body).unshift.apply(_node$body$body, paramChecks);
          var isVoid = node.returnType ? maybeNullableAnnotation(node.returnType) : null;
          node.savedTypeAnnotation = node.returnType;
          stack.push({ node: node, returns: 0, isVoid: isVoid, type: node.returnType });
        },
        exit: function exit(path) {
          if (!NodePath(path)) {
            throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
          }

          var _stack$pop = stack.pop();

          var node = _stack$pop.node;
          var returns = _stack$pop.returns;
          var isVoid = _stack$pop.isVoid;
          var type = _stack$pop.type;

          if (isVoid === false && returns === 0) {
            throw path.buildCodeFrameError('Function ' + (node.id ? '"' + node.id.name + '" ' : '') + 'did not return a value, expected ' + humanReadableType(type, path.scope));
          }
        }
      },

      ReturnStatement: function ReturnStatement(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;
        var parent = path.parent;
        var scope = path.scope;

        if (stack.length === 0 || node.isTypeChecked) {
          return;
        }
        stack[stack.length - 1].returns++;
        var fn = stack[stack.length - 1].node;
        var returnType = fn.returnType;

        if (!returnType) {
          return;
        }
        if (!node.argument) {
          if (maybeNullableAnnotation(returnType) === false) {
            throw path.buildCodeFrameError('Function ' + (fn.id ? '"' + fn.id.name + '" ' : '') + 'did not return a value, expected ' + humanReadableType(returnType, path.scope));
          }
          return;
        }
        var id = undefined;
        if (node.argument.type === 'Identifier') {
          id = node.argument;
        } else {
          id = scope.generateUidIdentifierBasedOnNode(node.argument);
        }
        var ok = staticCheckAnnotation(path.get("argument"), returnType);
        if (ok === true) {
          return;
        } else if (ok === false) {
          throw path.buildCodeFrameError('Invalid return type, expected ' + humanReadableType(returnType, scope));
        }
        var check = checkAnnotation(id, returnType, scope);
        if (!check) {
          return;
        }
        if (parent.type !== 'BlockStatement' && parent.type !== 'Program') {
          var block = [];
          if (node.argument.type !== 'Identifier') {
            scope.push({ id: id });
            block.push(t.expressionStatement(t.assignmentExpression('=', id, node.argument)));
          }
          var ret = t.returnStatement(id);
          ret.isTypeChecked = true;
          block.push(thrower({
            check: check,
            ret: ret,
            message: returnTypeErrorMessage(path, fn, id)
          }));
          path.replaceWith(t.blockStatement(block));
        } else {
          if (node.argument.type !== 'Identifier') {
            scope.push({ id: id });
            path.insertBefore(t.expressionStatement(t.assignmentExpression('=', id, node.argument)));
          }
          var ret = t.returnStatement(id);
          ret.isTypeChecked = true;
          path.replaceWith(thrower({
            check: check,
            ret: ret,
            message: returnTypeErrorMessage(path, fn, id)
          }));
        }
      },
      VariableDeclaration: function VariableDeclaration(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;
        var scope = path.scope;

        var collected = [];
        var declarations = path.get("declarations");
        for (var i = 0; i < node.declarations.length; i++) {
          var declaration = node.declarations[i];
          var id = declaration.id;
          var init = declaration.init;

          if (!id.typeAnnotation || id.hasBeenTypeChecked) {
            continue;
          }
          id.savedTypeAnnotation = id.typeAnnotation;
          id.hasBeenTypeChecked = true;
          var ok = staticCheckAnnotation(declarations[i], id.typeAnnotation);
          if (ok === true) {
            continue;
          } else if (ok === false) {
            throw path.buildCodeFrameError('Invalid assignment value, expected ' + humanReadableType(id.typeAnnotation, scope));
          }
          var check = checkAnnotation(id, id.typeAnnotation, scope);
          if (check) {
            collected.push(guard({
              check: check,
              message: varTypeErrorMessage(id, scope)
            }));
          }
        }
        if (collected.length > 0) {
          var check = collected.reduce(function (check, branch) {
            branch.alternate = check;
            return branch;
          });
          if (path.parent.type === 'Program' || path.parent.type === 'BlockStatement') {
            path.insertAfter(check);
          } else {
            path.replaceWith(t.blockStatement([node, check]));
          }
        }
      },
      AssignmentExpression: function AssignmentExpression(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;
        var scope = path.scope;

        if (node.hasBeenTypeChecked || node.left.hasBeenTypeChecked) {
          return;
        }
        var binding = scope.getBinding(node.left.name);
        if (!binding || binding.path.type !== 'VariableDeclarator') {
          return;
        }
        var annotation = path.get('left').getTypeAnnotation();
        if (annotation.type === 'AnyTypeAnnotation') {
          var item = binding.path.get('id');
          annotation = item.node.savedTypeAnnotation || item.getTypeAnnotation();
        }

        node.hasBeenTypeChecked = true;
        node.left.hasBeenTypeChecked = true;
        if (annotation.type === 'AnyTypeAnnotation') {
          annotation = getAnnotation(path.get('right'));

          if (!TypeAnnotation(annotation)) {
            throw new TypeError('Value of variable "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
          }

          if (allowsAny(annotation)) {
            return;
          }
        }
        var id = node.left;
        var right = path.get('right');
        var ok = staticCheckAnnotation(right, annotation);
        if (ok === true) {
          return;
        } else if (ok === false) {
          throw path.buildCodeFrameError('Invalid assignment value, expected ' + humanReadableType(annotation, scope));
        }
        var check = checkAnnotation(id, annotation, scope);
        if (!id.typeAnnotation) {
          id.typeAnnotation = annotation;
        }
        id.hasBeenTypeChecked = true;
        if (check) {
          path.getStatementParent().insertAfter(guard({
            check: check,
            message: varTypeErrorMessage(id, scope)
          }));
        }
      },
      TypeCastExpression: function TypeCastExpression(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;

        var target = undefined;
        switch (node.expression.type) {
          case 'Identifier':
            target = node.expression;
            break;
          case 'AssignmentExpression':
            target = node.expression.left;
            break;
          default:
            // unsupported.
            return;
        }
        var id = path.scope.getBindingIdentifier(target.name);
        if (!id) {
          return;
        }
        id.savedTypeAnnotation = path.getTypeAnnotation();
      }
    }
  };

  function createChecks() {
    return {
      number: template('typeof input === \'number\''),
      boolean: template('typeof input === \'boolean\''),
      function: template('typeof input === \'function\''),
      string: template('typeof input === \'string\''),
      symbol: template('typeof input === \'symbol\''),
      undefined: template('input === undefined'),
      null: template('input === null'),
      nullOrUndefined: template('input == null'),
      instanceof: template('input instanceof type'),
      type: template('type(input)'),
      mixed: function mixed() {
        return null;
      },
      any: function any() {
        return template('input != null').expression;
      },
      union: checkUnion,
      intersection: checkIntersection,
      array: checkArray,
      map: checkMap,
      set: checkSet,
      tuple: checkTuple,
      object: checkObject,
      nullable: checkNullable,
      typeof: checkTypeof
    };
  }

  function createStaticChecks() {
    return {
      string: function string(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        return maybeStringAnnotation(getAnnotation(path));
      },
      number: function number(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        return maybeNumberAnnotation(getAnnotation(path));
      },
      boolean: function boolean(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        return maybeBooleanAnnotation(getAnnotation(path));
      },
      function: function _function(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        return maybeFunctionAnnotation(getAnnotation(path));
      },
      any: function any(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        return null;
      },
      instanceof: function _instanceof(_ref6) {
        var path = _ref6.path;
        var type = _ref6.type;
        var node = path.node;
        var scope = path.scope;

        if (type.name === 'Object' && !scope.hasBinding('Object') && node.type === 'ObjectExpression') {
          return true;
        }
        return maybeInstanceOfAnnotation(getAnnotation(path), type);
      },
      type: (function (_type) {
        function type(_x) {
          return _type.apply(this, arguments);
        }

        type.toString = function () {
          return _type.toString();
        };

        return type;
      })(function (_ref7) {
        var path = _ref7.path;
        var type = _ref7.type;

        return null;
      }),
      array: function array(_ref8) {
        var path = _ref8.path;
        var types = _ref8.types;
        var node = path.node;

        if (node.type === 'ArrayExpression') {
          if (types.length === 0) {
            return true;
          } else if (node.elements.length < types.length) {
            return false;
          } else {
            return null;
          }
        } else if (maybeArrayAnnotation(getAnnotation(path)) === false) {
          return false;
        } else {
          return null;
        }
      },
      tuple: function tuple(_ref9) {
        var path = _ref9.path;
        var types = _ref9.types;
        var node = path.node;

        var annotation = getAnnotation(path);
        if (annotation.type === 'TypeAnnotation' || annotation.type === 'NullableTypeAnnotation') {
          annotation = annotation.typeAnnotation;
        }
        //console.log('TUPLE!');
        return maybeTupleAnnotation(annotation);
      },

      union: checkStaticUnion,
      intersection: checkStaticIntersection,
      object: checkStaticObject,
      nullable: checkStaticNullable
    };
  }

  function compareAnnotations(a, b) {
    if (!TypeAnnotation(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected TypeAnnotation got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!TypeAnnotation(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected TypeAnnotation got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (a.type === 'TypeAnnotation') {
      a = a.typeAnnotation;
    }
    if (b.type === 'TypeAnnotation') {
      b = b.typeAnnotation;
    }
    switch (a.type) {
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
        return maybeStringAnnotation(b);
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
        return maybeNumberAnnotation(b);
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
        return maybeBooleanAnnotation(b);
      case 'FunctionTypeAnnotation':
        return maybeFunctionAnnotation(b);
      case 'AnyTypeAnnotation':
        return null;
      case 'MixedTypeAnnotation':
        return null;
      case 'ObjectTypeAnnotation':
        return compareObjectAnnotation(a, b);
      case 'ArrayTypeAnnotation':
        return compareArrayAnnotation(a, b);
      case 'GenericTypeAnnotation':
        return compareGenericAnnotation(a, b);
      case 'TupleTypeAnnotation':
        return compareTupleAnnotation(a, b);
      case 'UnionTypeAnnotation':
        return compareUnionAnnotation(a, b);
      case 'IntersectionTypeAnnotation':
        return compareIntersectionAnnotation(a, b);
      case 'NullableTypeAnnotation':
        return compareNullableAnnotation(a, b);
      default:
        return null;
    }
  }

  function unionComparer(a, b, comparator) {
    if (!TypeAnnotation(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected TypeAnnotation got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!TypeAnnotation(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected TypeAnnotation got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (!(typeof comparator === 'function')) {
      throw new TypeError('Value of argument "comparator" violates contract, expected (a: TypeAnnotation, b: TypeAnnotation) => ?bool got ' + (comparator === null ? 'null' : (typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)) === 'object' && comparator.constructor ? comparator.constructor.name || '[Unknown Object]' : typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)));
    }

    var falseCount = 0;
    var trueCount = 0;
    if (!a.types) {
      //console.trace(a.type);
      return null;
    }
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = a.types[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _type2 = _step.value;

        var result = comparator(_type2, b);
        if (result === true) {
          if (b.type !== 'UnionTypeAnnotation') {
            return true;
          }
          trueCount++;
        } else if (result === false) {
          if (b.type === 'UnionTypeAnnotation') {
            return false;
          }
          falseCount++;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    if (falseCount === a.types.length) {
      return false;
    } else if (trueCount === a.types.length) {
      return true;
    } else {
      return null;
    }
  }

  function intersectionComparer(a, b, comparator) {
    if (!TypeAnnotation(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected TypeAnnotation got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!TypeAnnotation(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected TypeAnnotation got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (!(typeof comparator === 'function')) {
      throw new TypeError('Value of argument "comparator" violates contract, expected (a: TypeAnnotation, b: TypeAnnotation) => ?bool got ' + (comparator === null ? 'null' : (typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)) === 'object' && comparator.constructor ? comparator.constructor.name || '[Unknown Object]' : typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)));
    }

    var falseCount = 0;
    var trueCount = 0;
    if (!a.types) {
      return null;
    }
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = a.types[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var _type3 = _step2.value;

        var result = comparator(_type3, b);
        if (result === true) {
          trueCount++;
        } else if (result === false) {
          return false;
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    if (trueCount === a.types.length) {
      return true;
    } else {
      return null;
    }
  }

  function compareObjectAnnotation(a, b) {
    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return compareObjectAnnotation(a, b.typeAnnotation);
      case 'UnionTypeAnnotation':
        return unionComparer(a, b, compareObjectAnnotation);
      case 'IntersectionTypeAnnotation':
        return intersectionComparer(a, b, compareObjectAnnotation);
      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        return null;
    }
  }

  function compareArrayAnnotation(a, b) {
    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return compareArrayAnnotation(a, b.typeAnnotation);
      case 'UnionTypeAnnotation':
        return unionComparer(a, b, compareArrayAnnotation);
      case 'IntersectionTypeAnnotation':
        return intersectionComparer(a, b, compareArrayAnnotation);
      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        return null;
    }
  }

  function compareGenericAnnotation(a, b) {
    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return compareGenericAnnotation(a, b.typeAnnotation);
      case 'GenericTypeAnnotation':
        if (b.id.name === a.id.name) {
          return true;
        } else {
          return null;
        }
      case 'UnionTypeAnnotation':
        return unionComparer(a, b, compareGenericAnnotation);
      case 'IntersectionTypeAnnotation':
        return intersectionComparer(a, b, compareGenericAnnotation);
      default:
        return null;
    }
  }

  function compareTupleAnnotation(a, b) {
    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (b.type === 'TupleTypeAnnotation') {
      if (b.types.length === 0) {
        return null;
      } else if (b.types.length < a.types.length) {
        return false;
      }
      return a.types.every(function (type, index) {
        return compareAnnotations(type, b.types[index]);
      });
    }
    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return compareTupleAnnotation(a, b.typeAnnotation);
      case 'UnionTypeAnnotation':
        return unionComparer(a, b, compareTupleAnnotation);
      case 'IntersectionTypeAnnotation':
        return intersectionComparer(a, b, compareTupleAnnotation);
      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        return null;
    }
  }

  function compareUnionAnnotation(a, b) {
    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'NullableTypeAnnotation':
        return compareUnionAnnotation(a, b.typeAnnotation);
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
        return null;
      default:
        return unionComparer(a, b, compareAnnotations);
    }
  }

  function compareNullableAnnotation(a, b) {
    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return compareNullableAnnotation(a, b.typeAnnotation);
      case 'NullableTypeAnnotation':
      case 'VoidTypeAnnotation':
        return null;
    }
    if (compareAnnotations(a.typeAnnotation, b) === true) {
      return true;
    } else {
      return null;
    }
  }

  function arrayExpressionToTupleAnnotation(path) {
    var _t$tupleTypeAnnotatio;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var elements = path.get('elements');
    _t$tupleTypeAnnotatio = t.tupleTypeAnnotation(elements.map(function (element) {
      return getAnnotation(element);
    }));

    if (TypeAnnotation(_t$tupleTypeAnnotatio)) {
      return _t$tupleTypeAnnotatio;
    } else {
      throw new TypeError('Function "arrayExpressionToTupleAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$tupleTypeAnnotatio === null ? 'null' : (typeof _t$tupleTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$tupleTypeAnnotatio)) === 'object' && _t$tupleTypeAnnotatio.constructor ? _t$tupleTypeAnnotatio.constructor.name || '[Unknown Object]' : typeof _t$tupleTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$tupleTypeAnnotatio)));
    }
  }

  function checkStaticUnion(_ref26) {
    var path = _ref26.path;
    var types = _ref26.types;

    var falseCount = 0;
    var nullCount = 0;
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = types[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var _type4 = _step3.value;

        var result = staticCheckAnnotation(path, _type4);
        if (result === true) {
          return true;
        } else if (result === false) {
          falseCount++;
        } else {
          nullCount++;
        }
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3.return) {
          _iterator3.return();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }

    if (falseCount === types.length) {
      return false;
    } else {
      return null;
    }
  }

  function checkStaticIntersection(_ref27) {
    var path = _ref27.path;
    var types = _ref27.types;

    var trueCount = 0;
    var _iteratorNormalCompletion4 = true;
    var _didIteratorError4 = false;
    var _iteratorError4 = undefined;

    try {
      for (var _iterator4 = types[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
        var _type5 = _step4.value;

        var result = staticCheckAnnotation(path, _type5);
        if (result === true) {
          trueCount++;
        } else if (result === false) {
          return false;
        }
      }
    } catch (err) {
      _didIteratorError4 = true;
      _iteratorError4 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion4 && _iterator4.return) {
          _iterator4.return();
        }
      } finally {
        if (_didIteratorError4) {
          throw _iteratorError4;
        }
      }
    }

    if (trueCount === types.length) {
      return true;
    } else {
      return null;
    }
  }

  function checkStaticObject(_ref28) {
    var path = _ref28.path;
    var type = _ref28.type;
  }

  function checkStaticNullable(_ref29) {
    var path = _ref29.path;
    var type = _ref29.type;

    var annotation = getAnnotation(path);
    if (annotation.type === 'VoidTypeAnnotation' || annotation.type === 'NullableTypeAnnotation') {
      return true;
    } else {
      return staticCheckAnnotation(path, type);
    }
  }

  function checkNullable(_ref30) {
    var input = _ref30.input;
    var type = _ref30.type;
    var scope = _ref30.scope;

    var check = checkAnnotation(input, type, scope);
    if (!check) {
      return;
    }
    return t.logicalExpression("||", checks.undefined({ input: input }).expression, check);
  }

  function checkTypeof(_ref31) {
    var input = _ref31.input;
    var annotation = _ref31.annotation;
    var scope = _ref31.scope;

    switch (annotation.type) {
      case 'GenericTypeAnnotation':
        var id = annotation.id;

        var path = { type: id.type, node: id, scope: scope };
        return checkAnnotation(input, getAnnotation(path), scope);
      default:
        return checkAnnotation(input, annotation, scope);
    }
  }

  function checkUnion(_ref32) {
    var input = _ref32.input;
    var types = _ref32.types;
    var scope = _ref32.scope;

    var checks = types.map(function (type) {
      return checkAnnotation(input, type, scope);
    }).filter(identity);
    return checks.reduce(function (last, check, index) {
      if (last == null) {
        return check;
      }
      return t.logicalExpression("||", last, check);
    }, null);
  }

  function checkIntersection(_ref33) {
    var input = _ref33.input;
    var types = _ref33.types;
    var scope = _ref33.scope;

    var checks = types.map(function (type) {
      return checkAnnotation(input, type, scope);
    }).filter(identity);
    return checks.reduce(function (last, check, index) {
      if (last == null) {
        return check;
      }
      return t.logicalExpression("&&", last, check);
    }, null);
  }

  function checkMap(_ref34) {
    var input = _ref34.input;
    var types = _ref34.types;
    var scope = _ref34.scope;

    var _types = _slicedToArray(types, 2);

    var keyType = _types[0];
    var valueType = _types[1];

    var key = t.identifier('key');
    var value = t.identifier('value');
    var keyCheck = keyType ? checkAnnotation(key, keyType, scope) : null;
    var valueCheck = valueType ? checkAnnotation(value, valueType, scope) : null;
    if (!keyCheck) {
      if (!valueCheck) {
        var _checkIsMap$expressio;

        _checkIsMap$expressio = checkIsMap({ input: input }).expression;

        if (Node(_checkIsMap$expressio)) {
          return _checkIsMap$expressio;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkIsMap$expressio === null ? 'null' : (typeof _checkIsMap$expressio === 'undefined' ? 'undefined' : _typeof(_checkIsMap$expressio)) === 'object' && _checkIsMap$expressio.constructor ? _checkIsMap$expressio.constructor.name || '[Unknown Object]' : typeof _checkIsMap$expressio === 'undefined' ? 'undefined' : _typeof(_checkIsMap$expressio)));
        }
      } else {
        var _checkMapValues$expre;

        _checkMapValues$expre = checkMapValues({ input: input, value: value, valueCheck: valueCheck }).expression;

        if (Node(_checkMapValues$expre)) {
          return _checkMapValues$expre;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkMapValues$expre === null ? 'null' : (typeof _checkMapValues$expre === 'undefined' ? 'undefined' : _typeof(_checkMapValues$expre)) === 'object' && _checkMapValues$expre.constructor ? _checkMapValues$expre.constructor.name || '[Unknown Object]' : typeof _checkMapValues$expre === 'undefined' ? 'undefined' : _typeof(_checkMapValues$expre)));
        }
      }
    } else {
      if (!valueCheck) {
        var _checkMapKeys$express;

        _checkMapKeys$express = checkMapKeys({ input: input, key: key, keyCheck: keyCheck }).expression;

        if (Node(_checkMapKeys$express)) {
          return _checkMapKeys$express;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkMapKeys$express === null ? 'null' : (typeof _checkMapKeys$express === 'undefined' ? 'undefined' : _typeof(_checkMapKeys$express)) === 'object' && _checkMapKeys$express.constructor ? _checkMapKeys$express.constructor.name || '[Unknown Object]' : typeof _checkMapKeys$express === 'undefined' ? 'undefined' : _typeof(_checkMapKeys$express)));
        }
      } else {
        var _checkMapEntries$expr;

        _checkMapEntries$expr = checkMapEntries({ input: input, key: key, value: value, keyCheck: keyCheck, valueCheck: valueCheck }).expression;

        if (Node(_checkMapEntries$expr)) {
          return _checkMapEntries$expr;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkMapEntries$expr === null ? 'null' : (typeof _checkMapEntries$expr === 'undefined' ? 'undefined' : _typeof(_checkMapEntries$expr)) === 'object' && _checkMapEntries$expr.constructor ? _checkMapEntries$expr.constructor.name || '[Unknown Object]' : typeof _checkMapEntries$expr === 'undefined' ? 'undefined' : _typeof(_checkMapEntries$expr)));
        }
      }
    }
  }

  function checkSet(_ref35) {
    var input = _ref35.input;
    var types = _ref35.types;
    var scope = _ref35.scope;

    var _types2 = _slicedToArray(types, 1);

    var valueType = _types2[0];

    var value = t.identifier('value');
    var valueCheck = valueType ? checkAnnotation(value, valueType, scope) : null;
    if (!valueCheck) {
      var _checkIsSet$expressio;

      _checkIsSet$expressio = checkIsSet({ input: input }).expression;

      if (Node(_checkIsSet$expressio)) {
        return _checkIsSet$expressio;
      } else {
        throw new TypeError('Function "checkSet" return value violates contract, expected Node got ' + (_checkIsSet$expressio === null ? 'null' : (typeof _checkIsSet$expressio === 'undefined' ? 'undefined' : _typeof(_checkIsSet$expressio)) === 'object' && _checkIsSet$expressio.constructor ? _checkIsSet$expressio.constructor.name || '[Unknown Object]' : typeof _checkIsSet$expressio === 'undefined' ? 'undefined' : _typeof(_checkIsSet$expressio)));
      }
    } else {
      var _checkSetEntries$expr;

      _checkSetEntries$expr = checkSetEntries({ input: input, value: value, valueCheck: valueCheck }).expression;

      if (Node(_checkSetEntries$expr)) {
        return _checkSetEntries$expr;
      } else {
        throw new TypeError('Function "checkSet" return value violates contract, expected Node got ' + (_checkSetEntries$expr === null ? 'null' : (typeof _checkSetEntries$expr === 'undefined' ? 'undefined' : _typeof(_checkSetEntries$expr)) === 'object' && _checkSetEntries$expr.constructor ? _checkSetEntries$expr.constructor.name || '[Unknown Object]' : typeof _checkSetEntries$expr === 'undefined' ? 'undefined' : _typeof(_checkSetEntries$expr)));
      }
    }
  }
  function checkArray(_ref36) {
    var input = _ref36.input;
    var types = _ref36.types;
    var scope = _ref36.scope;

    if (types.length === 0) {
      var _checkIsArray$express;

      _checkIsArray$express = checkIsArray({ input: input }).expression;

      if (Node(_checkIsArray$express)) {
        return _checkIsArray$express;
      } else {
        throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_checkIsArray$express === null ? 'null' : (typeof _checkIsArray$express === 'undefined' ? 'undefined' : _typeof(_checkIsArray$express)) === 'object' && _checkIsArray$express.constructor ? _checkIsArray$express.constructor.name || '[Unknown Object]' : typeof _checkIsArray$express === 'undefined' ? 'undefined' : _typeof(_checkIsArray$express)));
      }
    } else if (types.length === 1) {
      var _t$logicalExpression2;

      var item = t.identifier('item');
      var _type6 = types[0];
      var check = checkAnnotation(item, _type6, scope);
      if (!check) {
        var _checkIsArray$express2;

        _checkIsArray$express2 = checkIsArray({ input: input }).expression;

        if (Node(_checkIsArray$express2)) {
          return _checkIsArray$express2;
        } else {
          throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_checkIsArray$express2 === null ? 'null' : (typeof _checkIsArray$express2 === 'undefined' ? 'undefined' : _typeof(_checkIsArray$express2)) === 'object' && _checkIsArray$express2.constructor ? _checkIsArray$express2.constructor.name || '[Unknown Object]' : typeof _checkIsArray$express2 === 'undefined' ? 'undefined' : _typeof(_checkIsArray$express2)));
        }
      }
      _t$logicalExpression2 = t.logicalExpression('&&', checkIsArray({ input: input }).expression, t.callExpression(t.memberExpression(input, t.identifier('every')), [t.functionExpression(null, [item], t.blockStatement([t.returnStatement(check)]))]));

      if (Node(_t$logicalExpression2)) {
        return _t$logicalExpression2;
      } else {
        throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_t$logicalExpression2 === null ? 'null' : (typeof _t$logicalExpression2 === 'undefined' ? 'undefined' : _typeof(_t$logicalExpression2)) === 'object' && _t$logicalExpression2.constructor ? _t$logicalExpression2.constructor.name || '[Unknown Object]' : typeof _t$logicalExpression2 === 'undefined' ? 'undefined' : _typeof(_t$logicalExpression2)));
      }
    } else {
      var _checks$reduce3;

      // This is a tuple
      var _checks = types.map(function (type, index) {
        return checkAnnotation(t.memberExpression(input, t.numericLiteral(index), true), type, scope);
      }).filter(identity);

      var checkLength = t.binaryExpression('>=', t.memberExpression(input, t.identifier('length')), t.numericLiteral(types.length));

      _checks$reduce3 = _checks.reduce(function (last, check, index) {
        return t.logicalExpression("&&", last, check);
      }, t.logicalExpression('&&', checkIsArray({ input: input }).expression, checkLength));

      if (Node(_checks$reduce3)) {
        return _checks$reduce3;
      } else {
        throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_checks$reduce3 === null ? 'null' : (typeof _checks$reduce3 === 'undefined' ? 'undefined' : _typeof(_checks$reduce3)) === 'object' && _checks$reduce3.constructor ? _checks$reduce3.constructor.name || '[Unknown Object]' : typeof _checks$reduce3 === 'undefined' ? 'undefined' : _typeof(_checks$reduce3)));
      }
    }
  }

  function checkTuple(_ref37) {
    var _checks$reduce4;

    var input = _ref37.input;
    var types = _ref37.types;
    var scope = _ref37.scope;

    if (types.length === 0) {
      var _checkIsArray$express3;

      _checkIsArray$express3 = checkIsArray({ input: input }).expression;

      if (Node(_checkIsArray$express3)) {
        return _checkIsArray$express3;
      } else {
        throw new TypeError('Function "checkTuple" return value violates contract, expected Node got ' + (_checkIsArray$express3 === null ? 'null' : (typeof _checkIsArray$express3 === 'undefined' ? 'undefined' : _typeof(_checkIsArray$express3)) === 'object' && _checkIsArray$express3.constructor ? _checkIsArray$express3.constructor.name || '[Unknown Object]' : typeof _checkIsArray$express3 === 'undefined' ? 'undefined' : _typeof(_checkIsArray$express3)));
      }
    }

    // This is a tuple
    var checks = types.map(function (type, index) {
      return checkAnnotation(t.memberExpression(input, t.numericLiteral(index), true), type, scope);
    }).filter(identity);

    var checkLength = t.binaryExpression('>=', t.memberExpression(input, t.identifier('length')), t.numericLiteral(types.length));

    _checks$reduce4 = checks.reduce(function (last, check, index) {
      return t.logicalExpression("&&", last, check);
    }, t.logicalExpression('&&', checkIsArray({ input: input }).expression, checkLength));

    if (Node(_checks$reduce4)) {
      return _checks$reduce4;
    } else {
      throw new TypeError('Function "checkTuple" return value violates contract, expected Node got ' + (_checks$reduce4 === null ? 'null' : (typeof _checks$reduce4 === 'undefined' ? 'undefined' : _typeof(_checks$reduce4)) === 'object' && _checks$reduce4.constructor ? _checks$reduce4.constructor.name || '[Unknown Object]' : typeof _checks$reduce4 === 'undefined' ? 'undefined' : _typeof(_checks$reduce4)));
    }
  }

  function checkObject(_ref38) {
    var _properties$reduce;

    var input = _ref38.input;
    var properties = _ref38.properties;
    var scope = _ref38.scope;
    _properties$reduce = properties.reduce(function (expr, prop, index) {
      var target = t.memberExpression(input, prop.key);
      var check = checkAnnotation(target, prop.value, scope);
      if (check) {
        if (prop.optional) {
          check = t.logicalExpression('||', checks.undefined({ input: target }).expression, check);
        }
        return t.logicalExpression("&&", expr, check);
      } else {
        return expr;
      }
    }, checkIsObject({ input: input }).expression);

    if (Node(_properties$reduce)) {
      return _properties$reduce;
    } else {
      throw new TypeError('Function "checkObject" return value violates contract, expected Node got ' + (_properties$reduce === null ? 'null' : (typeof _properties$reduce === 'undefined' ? 'undefined' : _typeof(_properties$reduce)) === 'object' && _properties$reduce.constructor ? _properties$reduce.constructor.name || '[Unknown Object]' : typeof _properties$reduce === 'undefined' ? 'undefined' : _typeof(_properties$reduce)));
    }
  }

  function createTypeAliasChecks(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.id;
    var annotation = node.right;

    var input = t.identifier('input');
    var check = checkAnnotation(input, annotation, scope) || t.booleanLiteral(true);
    var declaration = declareTypeChecker({ id: id, check: check });
    declaration.isTypeChecker = true;

    if (Node(declaration)) {
      return declaration;
    } else {
      throw new TypeError('Function "createTypeAliasChecks" return value violates contract, expected Node got ' + (declaration === null ? 'null' : (typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)) === 'object' && declaration.constructor ? declaration.constructor.name || '[Unknown Object]' : typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)));
    }
  }

  function createInterfaceChecks(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.id;
    var annotation = node.body;

    var input = t.identifier('input');
    var check = node.extends.reduce(function (check, extender) {
      return t.logicalExpression('&&', check, checkAnnotation(input, t.genericTypeAnnotation(extender.id), path.scope));
      return check;
    }, checkAnnotation(input, annotation, scope) || t.booleanLiteral(true));

    var declaration = declareTypeChecker({ id: id, check: check });
    declaration.isTypeChecker = true;

    if (Node(declaration)) {
      return declaration;
    } else {
      throw new TypeError('Function "createInterfaceChecks" return value violates contract, expected Node got ' + (declaration === null ? 'null' : (typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)) === 'object' && declaration.constructor ? declaration.constructor.name || '[Unknown Object]' : typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)));
    }
  }

  function checkAnnotation(input, annotation, scope) {
    if (!Node(input)) {
      throw new TypeError('Value of argument "input" violates contract, expected Node got ' + (input === null ? 'null' : (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && input.constructor ? input.constructor.name || '[Unknown Object]' : typeof input === 'undefined' ? 'undefined' : _typeof(input)));
    }

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return checkAnnotation(input, annotation.typeAnnotation, scope);
      case 'TypeofTypeAnnotation':
        return checks.typeof({ input: input, annotation: annotation.argument, scope: scope });
      case 'GenericTypeAnnotation':
        if (annotation.id.name === 'Array') {
          return checks.array({ input: input, types: annotation.typeParameters ? annotation.typeParameters.params : [], scope: scope });
        } else if (annotation.id.name === 'Map' && !scope.hasBinding('Map')) {
          return checks.map({ input: input, types: annotation.typeParameters ? annotation.typeParameters.params : [], scope: scope });
        } else if (annotation.id.name === 'Set' && !scope.hasBinding('Set')) {
          return checks.set({ input: input, types: annotation.typeParameters ? annotation.typeParameters.params : [], scope: scope });
        } else if (annotation.id.name === 'Function') {
          return checks.function({ input: input }).expression;
        } else if (isTypeChecker(annotation.id, scope)) {
          return checks.type({ input: input, type: annotation.id }).expression;
        } else if (isPolymorphicType(annotation.id, scope)) {
          return;
        } else {
          return checks.instanceof({ input: input, type: createTypeExpression(annotation.id) }).expression;
        }
      case 'TupleTypeAnnotation':
        return checks.tuple({ input: input, types: annotation.types, scope: scope });
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
        return checks.number({ input: input }).expression;
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
        return checks.boolean({ input: input }).expression;
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
        return checks.string({ input: input }).expression;
      case 'UnionTypeAnnotation':
        return checks.union({ input: input, types: annotation.types, scope: scope });
      case 'IntersectionTypeAnnotation':
        return checks.intersection({ input: input, types: annotation.types, scope: scope });
      case 'ObjectTypeAnnotation':
        return checks.object({ input: input, properties: annotation.properties, scope: scope });
      case 'ArrayTypeAnnotation':
        return checks.array({ input: input, types: [annotation.elementType], scope: scope });
      case 'FunctionTypeAnnotation':
        return checks.function({ input: input, params: annotation.params, returnType: annotation.returnType });
      case 'MixedTypeAnnotation':
        return checks.mixed({ input: input });
      case 'AnyTypeAnnotation':
      case 'ExistentialTypeParam':
        return checks.any({ input: input });
      case 'NullableTypeAnnotation':
        return checks.nullable({ input: input, type: annotation.typeAnnotation, scope: scope }).expression;
      case 'VoidTypeAnnotation':
        return checks.undefined({ input: input }).expression;
    }
  }

  function staticCheckAnnotation(path, annotation) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    var other = getAnnotation(path);

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return staticCheckAnnotation(path, annotation.typeAnnotation);
      case 'GenericTypeAnnotation':
        if (isTypeChecker(annotation.id, path.scope)) {
          return staticChecks.type({ path: path, type: annotation.id });
        } else if (isPolymorphicType(annotation.id, path.scope)) {
          return;
        } else {
          return staticChecks.instanceof({ path: path, type: createTypeExpression(annotation.id) });
        }
    }

    return compareAnnotations(annotation, other);
  }

  /**
   * Get the type annotation for a given node.
   */
  function getAnnotation(path) {
    var _ref39;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var annotation = getAnnotationShallow(path);
    while (annotation && annotation.type === 'TypeAnnotation') {
      annotation = annotation.typeAnnotation;
    }
    _ref39 = annotation || t.anyTypeAnnotation();

    if (TypeAnnotation(_ref39)) {
      return _ref39;
    } else {
      throw new TypeError('Function "getAnnotation" return value violates contract, expected TypeAnnotation got ' + (_ref39 === null ? 'null' : (typeof _ref39 === 'undefined' ? 'undefined' : _typeof(_ref39)) === 'object' && _ref39.constructor ? _ref39.constructor.name || '[Unknown Object]' : typeof _ref39 === 'undefined' ? 'undefined' : _typeof(_ref39)));
    }
  }

  function getAnnotationShallow(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;

    if (node.type === 'TypeAlias') {
      return node.right;
    } else if (!node.typeAnnotation && !node.savedTypeAnnotation && !node.returnType) {
      switch (path.type) {
        case 'Identifier':
          var id = scope.getBindingIdentifier(node.name);
          if (!id) {
            break;
          }
          if (id.savedTypeAnnotation) {
            return id.savedTypeAnnotation;
          } else if (id.returnType) {
            return id.returnType;
          } else if (id.typeAnnotation) {
            return id.typeAnnotation;
          } else if (isPolymorphicType(id, scope)) {
            return t.anyTypeAnnotation();
          } else {
            var binding = scope.getBinding(node.name);
            var violation = getConstantViolationsBefore(binding, path).pop();
            if (violation) {
              return getAnnotation(violation);
            }
          }
          return path.getTypeAnnotation();
        case 'NumericLiteral':
        case 'StringLiteral':
        case 'BooleanLiteral':
          return path.getTypeAnnotation();
        case 'CallExpression':
          var callee = path.get('callee');
          if (callee.type === 'Identifier') {
            var fn = getFunctionForIdentifier(callee);
            if (fn) {
              return getAnnotation(fn);
            }
          }
          break;
        case 'AssignmentExpression':
          return getAssignmentExpressionAnnotation(path);
        case 'MemberExpression':
          return getMemberExpressionAnnotation(path);
        case 'ArrayExpression':
          return getArrayExpressionAnnotation(path);
        case 'ObjectExpression':
          return getObjectExpressionAnnotation(path);
        case 'BinaryExpression':
          return getBinaryExpressionAnnotation(path);
        case 'BinaryExpression':
          return getBinaryExpressionAnnotation(path);
        case 'LogicalExpression':
          return getLogicalExpressionAnnotation(path);
        case 'ConditionalExpression':
          return getConditionalExpressionAnnotation(path);
        default:
          return path.getTypeAnnotation();

      }
    }
    return node.savedTypeAnnotation || node.returnType || node.typeAnnotation || path.getTypeAnnotation();
  }

  function getObjectMethodAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    return t.functionTypeAnnotation(null, node.params.map(function (param) {
      return param.savedTypeAnnotation || param.typeAnnotation;
    }), null, node.savedTypeAnnotation || node.returnType || node.typeAnnotation || t.anyTypeAnnotation());
  }

  function getAssignmentExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (path.node.operator === '=') {
      return getAnnotation(path.get('right'));
    }
  }

  function getBinaryExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    if (isBooleanExpression(node)) {
      var _t$booleanTypeAnnotat;

      _t$booleanTypeAnnotat = t.booleanTypeAnnotation();

      if (TypeAnnotation(_t$booleanTypeAnnotat)) {
        return _t$booleanTypeAnnotat;
      } else {
        throw new TypeError('Function "getBinaryExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$booleanTypeAnnotat === null ? 'null' : (typeof _t$booleanTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat)) === 'object' && _t$booleanTypeAnnotat.constructor ? _t$booleanTypeAnnotat.constructor.name || '[Unknown Object]' : typeof _t$booleanTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat)));
      }
    } else {
      var _t$anyTypeAnnotation2;

      _t$anyTypeAnnotation2 = t.anyTypeAnnotation();

      if (TypeAnnotation(_t$anyTypeAnnotation2)) {
        return _t$anyTypeAnnotation2;
      } else {
        throw new TypeError('Function "getBinaryExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$anyTypeAnnotation2 === null ? 'null' : (typeof _t$anyTypeAnnotation2 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation2)) === 'object' && _t$anyTypeAnnotation2.constructor ? _t$anyTypeAnnotation2.constructor.name || '[Unknown Object]' : typeof _t$anyTypeAnnotation2 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation2)));
      }
    }
  }

  function getLogicalExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    if (isBooleanExpression(node)) {
      var _t$booleanTypeAnnotat2;

      _t$booleanTypeAnnotat2 = t.booleanTypeAnnotation();

      if (TypeAnnotation(_t$booleanTypeAnnotat2)) {
        return _t$booleanTypeAnnotat2;
      } else {
        throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$booleanTypeAnnotat2 === null ? 'null' : (typeof _t$booleanTypeAnnotat2 === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat2)) === 'object' && _t$booleanTypeAnnotat2.constructor ? _t$booleanTypeAnnotat2.constructor.name || '[Unknown Object]' : typeof _t$booleanTypeAnnotat2 === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat2)));
      }
    } else {
      var _t$anyTypeAnnotation3;

      var left = path.get('left');
      var right = path.get('right');
      switch (node.operator) {
        case '&&':
        case '||':
          var _ref41 = [getAnnotation(left), getAnnotation(right)];
          left = _ref41[0];
          right = _ref41[1];

          if (t.isUnionTypeAnnotation(left)) {
            if (t.isUnionTypeAnnotation(right)) {
              var _t$unionTypeAnnotatio;

              _t$unionTypeAnnotatio = t.unionTypeAnnotation(left.types.concat(right.types));

              if (TypeAnnotation(_t$unionTypeAnnotatio)) {
                return _t$unionTypeAnnotatio;
              } else {
                throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio === null ? 'null' : (typeof _t$unionTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio)) === 'object' && _t$unionTypeAnnotatio.constructor ? _t$unionTypeAnnotatio.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio)));
              }
            } else {
              var _t$unionTypeAnnotatio2;

              _t$unionTypeAnnotatio2 = t.unionTypeAnnotation(left.types.concat(right));

              if (TypeAnnotation(_t$unionTypeAnnotatio2)) {
                return _t$unionTypeAnnotatio2;
              } else {
                throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio2 === null ? 'null' : (typeof _t$unionTypeAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio2)) === 'object' && _t$unionTypeAnnotatio2.constructor ? _t$unionTypeAnnotatio2.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio2)));
              }
            }
          } else {
            var _t$unionTypeAnnotatio3;

            _t$unionTypeAnnotatio3 = t.unionTypeAnnotation([left, right]);

            if (TypeAnnotation(_t$unionTypeAnnotatio3)) {
              return _t$unionTypeAnnotatio3;
            } else {
              throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio3 === null ? 'null' : (typeof _t$unionTypeAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio3)) === 'object' && _t$unionTypeAnnotatio3.constructor ? _t$unionTypeAnnotatio3.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio3)));
            }
          }
      }
      _t$anyTypeAnnotation3 = t.anyTypeAnnotation();

      if (TypeAnnotation(_t$anyTypeAnnotation3)) {
        return _t$anyTypeAnnotation3;
      } else {
        throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$anyTypeAnnotation3 === null ? 'null' : (typeof _t$anyTypeAnnotation3 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation3)) === 'object' && _t$anyTypeAnnotation3.constructor ? _t$anyTypeAnnotation3.constructor.name || '[Unknown Object]' : typeof _t$anyTypeAnnotation3 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation3)));
      }
    }
  }

  function getConditionalExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    var consequent = getAnnotation(path.get('consequent'));
    var alternate = getAnnotation(path.get('alternate'));
    if (t.isUnionTypeAnnotation(consequent)) {
      if (t.isUnionTypeAnnotation(alternate)) {
        var _t$unionTypeAnnotatio4;

        _t$unionTypeAnnotatio4 = t.unionTypeAnnotation(consequent.types.concat(alternate.types));

        if (TypeAnnotation(_t$unionTypeAnnotatio4)) {
          return _t$unionTypeAnnotatio4;
        } else {
          throw new TypeError('Function "getConditionalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio4 === null ? 'null' : (typeof _t$unionTypeAnnotatio4 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio4)) === 'object' && _t$unionTypeAnnotatio4.constructor ? _t$unionTypeAnnotatio4.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio4 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio4)));
        }
      } else {
        var _t$unionTypeAnnotatio5;

        _t$unionTypeAnnotatio5 = t.unionTypeAnnotation(consequent.types.concat(alternate));

        if (TypeAnnotation(_t$unionTypeAnnotatio5)) {
          return _t$unionTypeAnnotatio5;
        } else {
          throw new TypeError('Function "getConditionalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio5 === null ? 'null' : (typeof _t$unionTypeAnnotatio5 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio5)) === 'object' && _t$unionTypeAnnotatio5.constructor ? _t$unionTypeAnnotatio5.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio5 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio5)));
        }
      }
    } else {
      var _t$unionTypeAnnotatio6;

      _t$unionTypeAnnotatio6 = t.unionTypeAnnotation([consequent, alternate]);

      if (TypeAnnotation(_t$unionTypeAnnotatio6)) {
        return _t$unionTypeAnnotatio6;
      } else {
        throw new TypeError('Function "getConditionalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio6 === null ? 'null' : (typeof _t$unionTypeAnnotatio6 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio6)) === 'object' && _t$unionTypeAnnotatio6.constructor ? _t$unionTypeAnnotatio6.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio6 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio6)));
      }
    }
  }

  function getArrayExpressionAnnotation(path) {
    var _t$genericTypeAnnotat;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    _t$genericTypeAnnotat = t.genericTypeAnnotation(t.identifier('Array'), path.get('elements').map(getAnnotation));

    if (TypeAnnotation(_t$genericTypeAnnotat)) {
      return _t$genericTypeAnnotat;
    } else {
      throw new TypeError('Function "getArrayExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$genericTypeAnnotat === null ? 'null' : (typeof _t$genericTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$genericTypeAnnotat)) === 'object' && _t$genericTypeAnnotat.constructor ? _t$genericTypeAnnotat.constructor.name || '[Unknown Object]' : typeof _t$genericTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$genericTypeAnnotat)));
    }
  }

  function getObjectExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var annotation = t.objectTypeAnnotation(path.get('properties').map(function (property) {
      if (property.computed) {
        return;
      }
      switch (property.type) {
        case 'ObjectMethod':
          return t.objectTypeProperty(t.identifier(property.node.key.name), getObjectMethodAnnotation(property));
        case 'ObjectProperty':
          return t.objectTypeProperty(t.identifier(property.node.key.name), property.node.value.savedTypeAnnotation || property.node.value.typeAnnotation || t.anyTypeAnnotation());
      }
    }).filter(identity));
    //console.log(generate(annotation).code);

    if (TypeAnnotation(annotation)) {
      return annotation;
    } else {
      throw new TypeError('Function "getObjectExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }
  }

  function getMemberExpressionAnnotation(path) {
    var _path$getTypeAnnotati4;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (path.node.computed) {
      var _getComputedMemberExp;

      _getComputedMemberExp = getComputedMemberExpressionAnnotation(path);

      if (!TypeAnnotation(_getComputedMemberExp)) {
        throw new TypeError('Value of variable "_getComputedMemberExp" violates contract, expected TypeAnnotation got ' + (_getComputedMemberExp === null ? 'null' : (typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)) === 'object' && _getComputedMemberExp.constructor ? _getComputedMemberExp.constructor.name || '[Unknown Object]' : typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)));
      }

      if (TypeAnnotation(_getComputedMemberExp)) {
        return _getComputedMemberExp;
      } else {
        throw new TypeError('Function "getMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_getComputedMemberExp === null ? 'null' : (typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)) === 'object' && _getComputedMemberExp.constructor ? _getComputedMemberExp.constructor.name || '[Unknown Object]' : typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)));
      }
    }
    var object = path.get('object');

    var _path$get = path.get('property');

    var id = _path$get.node;
    var name = id.name;

    var annotation = getAnnotation(object);
    if (annotation.type === 'NullableTypeAnnotation') {
      annotation = annotation.typeAnnotation;
    }
    if (annotation.type === 'GenericTypeAnnotation') {
      var target = path.scope.getBinding(annotation.id.name);
      if (target) {
        annotation = getAnnotation(target.path);
      }
    }
    switch (annotation.type) {
      case 'ObjectTypeAnnotation':
        var _iteratorNormalCompletion5 = true;
        var _didIteratorError5 = false;
        var _iteratorError5 = undefined;

        try {
          for (var _iterator5 = annotation.properties[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var _step5$value = _step5.value;
            var key = _step5$value.key;
            var value = _step5$value.value;

            if (key.name === id.name) {
              if (TypeAnnotation(value)) {
                return value;
              } else {
                throw new TypeError('Function "getMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (value === null ? 'null' : (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value.constructor ? value.constructor.name || '[Unknown Object]' : typeof value === 'undefined' ? 'undefined' : _typeof(value)));
              }
            }
          }
        } catch (err) {
          _didIteratorError5 = true;
          _iteratorError5 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }
          } finally {
            if (_didIteratorError5) {
              throw _iteratorError5;
            }
          }
        }

        break;
    }
    _path$getTypeAnnotati4 = path.getTypeAnnotation();

    if (TypeAnnotation(_path$getTypeAnnotati4)) {
      return _path$getTypeAnnotati4;
    } else {
      throw new TypeError('Function "getMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_path$getTypeAnnotati4 === null ? 'null' : (typeof _path$getTypeAnnotati4 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati4)) === 'object' && _path$getTypeAnnotati4.constructor ? _path$getTypeAnnotati4.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati4 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati4)));
    }
  }

  function getComputedMemberExpressionAnnotation(path) {
    var _path$getTypeAnnotati6;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var object = path.get('object');
    var property = path.get('property');
    var objectAnnotation = getAnnotation(object);
    if (objectAnnotation.type === 'TypeAnnotation' || objectAnnotation.type === 'NullableTypeAnnotation') {
      objectAnnotation = objectAnnotation.typeAnnotation;
    }
    var propertyAnnotation = getAnnotation(property);
    if (propertyAnnotation.type === 'TypeAnnotation' || propertyAnnotation.type === 'NullableTypeAnnotation') {
      propertyAnnotation = propertyAnnotation.typeAnnotation;
    }

    var _property$evaluate = property.evaluate();

    var confident = _property$evaluate.confident;
    var value = _property$evaluate.value;

    if (!confident) {
      var _path$getTypeAnnotati5;

      _path$getTypeAnnotati5 = path.getTypeAnnotation();

      if (TypeAnnotation(_path$getTypeAnnotati5)) {
        return _path$getTypeAnnotati5;
      } else {
        throw new TypeError('Function "getComputedMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_path$getTypeAnnotati5 === null ? 'null' : (typeof _path$getTypeAnnotati5 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati5)) === 'object' && _path$getTypeAnnotati5.constructor ? _path$getTypeAnnotati5.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati5 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati5)));
      }
    }
    switch (objectAnnotation.type) {
      case 'TupleTypeAnnotation':
        if (objectAnnotation.types.length === 0) {
          break;
        } else if (typeof value === 'number') {
          var _objectAnnotation$typ;

          if (!objectAnnotation.types[value]) {
            throw path.buildCodeFrameError('Invalid computed member expression for tuple: ' + humanReadableType(objectAnnotation, path.scope));
          }
          _objectAnnotation$typ = objectAnnotation.types[value];

          if (TypeAnnotation(_objectAnnotation$typ)) {
            return _objectAnnotation$typ;
          } else {
            throw new TypeError('Function "getComputedMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_objectAnnotation$typ === null ? 'null' : (typeof _objectAnnotation$typ === 'undefined' ? 'undefined' : _typeof(_objectAnnotation$typ)) === 'object' && _objectAnnotation$typ.constructor ? _objectAnnotation$typ.constructor.name || '[Unknown Object]' : typeof _objectAnnotation$typ === 'undefined' ? 'undefined' : _typeof(_objectAnnotation$typ)));
          }
        } else {
          throw path.buildCodeFrameError('Invalid computed member expression for tuple: ' + humanReadableType(objectAnnotation, path.scope));
        }
        break;
    }
    _path$getTypeAnnotati6 = path.getTypeAnnotation();

    if (TypeAnnotation(_path$getTypeAnnotati6)) {
      return _path$getTypeAnnotati6;
    } else {
      throw new TypeError('Function "getComputedMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_path$getTypeAnnotati6 === null ? 'null' : (typeof _path$getTypeAnnotati6 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati6)) === 'object' && _path$getTypeAnnotati6.constructor ? _path$getTypeAnnotati6.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati6 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati6)));
    }
  }

  function getFunctionForIdentifier(path) {
    var _ref42;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (path.type !== 'Identifier') {
      return false;
    }
    var ref = path.scope.getBinding(path.node.name);
    if (!ref) {
      return false;
    }
    _ref42 = t.isFunction(ref.path.parent) && ref.path.parentPath;

    if (typeof _ref42 === 'boolean' || Node(_ref42)) {
      return _ref42;
    } else {
      throw new TypeError('Function "getFunctionForIdentifier" return value violates contract, expected bool | Node got ' + (_ref42 === null ? 'null' : (typeof _ref42 === 'undefined' ? 'undefined' : _typeof(_ref42)) === 'object' && _ref42.constructor ? _ref42.constructor.name || '[Unknown Object]' : typeof _ref42 === 'undefined' ? 'undefined' : _typeof(_ref42)));
    }
  }

  /**
   * Returns `true` if the annotation is definitely for an array,
   * otherwise `false`.
   */
  function isStrictlyArrayAnnotation(annotation) {
    var _annotation$types$eve;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return isStrictlyArrayAnnotation(annotation.typeAnnotation);
      case 'GenericTypeAnnotation':
        return annotation.id.name === 'Array';
      case 'UnionTypeAnnotation':
        {
          _annotation$types$eve = annotation.types.every(isStrictlyArrayAnnotation);

          if (typeof _annotation$types$eve === 'boolean') {
            return _annotation$types$eve;
          } else {
            throw new TypeError('Function "isStrictlyArrayAnnotation" return value violates contract, expected bool got ' + (_annotation$types$eve === null ? 'null' : (typeof _annotation$types$eve === 'undefined' ? 'undefined' : _typeof(_annotation$types$eve)) === 'object' && _annotation$types$eve.constructor ? _annotation$types$eve.constructor.name || '[Unknown Object]' : typeof _annotation$types$eve === 'undefined' ? 'undefined' : _typeof(_annotation$types$eve)));
          }
        }

      default:
        return false;
    }
  }

  function compareMaybeUnion(annotation, comparator) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!(typeof comparator === 'function')) {
      throw new TypeError('Value of argument "comparator" violates contract, expected (node: TypeAnnotation) => ?bool got ' + (comparator === null ? 'null' : (typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)) === 'object' && comparator.constructor ? comparator.constructor.name || '[Unknown Object]' : typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)));
    }

    var falseCount = 0;
    var _iteratorNormalCompletion6 = true;
    var _didIteratorError6 = false;
    var _iteratorError6 = undefined;

    try {
      for (var _iterator6 = annotation.types[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
        var _type7 = _step6.value;

        var result = comparator(_type7);
        if (result === true) {
          return true;
        } else if (result === false) {
          falseCount++;
        }
      }
    } catch (err) {
      _didIteratorError6 = true;
      _iteratorError6 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion6 && _iterator6.return) {
          _iterator6.return();
        }
      } finally {
        if (_didIteratorError6) {
          throw _iteratorError6;
        }
      }
    }

    if (falseCount === annotation.types.length) {
      return false;
    } else {
      return null;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a number,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeNumberAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeNumberAnnotation(annotation.typeAnnotation);
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'String':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            return null;
        }
      case 'UnionTypeAnnotation':
        return compareMaybeUnion(annotation, maybeNumberAnnotation);
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        return null;
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a string,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeStringAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeStringAnnotation(annotation.typeAnnotation);
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'Number':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            return null;
        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion7 = true;
        var _didIteratorError7 = false;
        var _iteratorError7 = undefined;

        try {
          for (var _iterator7 = annotation.types[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
            var _type8 = _step7.value;

            var result = maybeStringAnnotation(_type8);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError7 = true;
          _iteratorError7 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion7 && _iterator7.return) {
              _iterator7.return();
            }
          } finally {
            if (_didIteratorError7) {
              throw _iteratorError7;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        return null;
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a boolean,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeBooleanAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeBooleanAnnotation(annotation.typeAnnotation);
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'String':
          case 'Number':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            return null;
        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
          for (var _iterator8 = annotation.types[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
            var _type9 = _step8.value;

            var result = maybeBooleanAnnotation(_type9);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError8 = true;
          _iteratorError8 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }
          } finally {
            if (_didIteratorError8) {
              throw _iteratorError8;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        return null;
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a function,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeFunctionAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeFunctionAnnotation(annotation.typeAnnotation);
      case 'FunctionTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Number':
          case 'Object':
          case 'String':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            return null;
        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion9 = true;
        var _didIteratorError9 = false;
        var _iteratorError9 = undefined;

        try {
          for (var _iterator9 = annotation.types[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
            var _type10 = _step9.value;

            var result = maybeFunctionAnnotation(_type10);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError9 = true;
          _iteratorError9 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion9 && _iterator9.return) {
              _iterator9.return();
            }
          } finally {
            if (_didIteratorError9) {
              throw _iteratorError9;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        return null;
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with an undefined or null type,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeNullableAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'NullableTypeAnnotation':
      case 'VoidTypeAnnotation':
      case 'MixedTypeAnnotation':
        return true;
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return maybeNullableAnnotation(annotation.typeAnnotation);
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Number':
          case 'Object':
          case 'String':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            return null;
        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion10 = true;
        var _didIteratorError10 = false;
        var _iteratorError10 = undefined;

        try {
          for (var _iterator10 = annotation.types[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
            var _type11 = _step10.value;

            var result = maybeNullableAnnotation(_type11);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError10 = true;
          _iteratorError10 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion10 && _iterator10.return) {
              _iterator10.return();
            }
          } finally {
            if (_didIteratorError10) {
              throw _iteratorError10;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with an object type,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeInstanceOfAnnotation(annotation, expected) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Identifier(expected)) {
      throw new TypeError('Value of argument "expected" violates contract, expected Identifier got ' + (expected === null ? 'null' : (typeof expected === 'undefined' ? 'undefined' : _typeof(expected)) === 'object' && expected.constructor ? expected.constructor.name || '[Unknown Object]' : typeof expected === 'undefined' ? 'undefined' : _typeof(expected)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeInstanceOfAnnotation(annotation.typeAnnotation);
      case 'GenericTypeAnnotation':
        if (annotation.id.name === expected.name) {
          return true;
        } else {
          return null;
        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion11 = true;
        var _didIteratorError11 = false;
        var _iteratorError11 = undefined;

        try {
          for (var _iterator11 = annotation.types[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
            var _type12 = _step11.value;

            var result = maybeInstanceOfAnnotation(_type12, expected);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError11 = true;
          _iteratorError11 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion11 && _iterator11.return) {
              _iterator11.return();
            }
          } finally {
            if (_didIteratorError11) {
              throw _iteratorError11;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        return null;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with an array,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeArrayAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeArrayAnnotation(annotation.typeAnnotation);
      case 'TupleTypeAnnotation':
      case 'ArrayTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        return annotation.id.name === 'Array' ? true : null;
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion12 = true;
        var _didIteratorError12 = false;
        var _iteratorError12 = undefined;

        try {
          for (var _iterator12 = annotation.types[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
            var _type13 = _step12.value;

            var result = maybeArrayAnnotation(_type13);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError12 = true;
          _iteratorError12 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion12 && _iterator12.return) {
              _iterator12.return();
            }
          } finally {
            if (_didIteratorError12) {
              throw _iteratorError12;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        return null;
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a tuple,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeTupleAnnotation(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        return maybeTupleAnnotation(annotation.typeAnnotation);
      case 'TupleTypeAnnotation':
        return true;
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion13 = true;
        var _didIteratorError13 = false;
        var _iteratorError13 = undefined;

        try {
          for (var _iterator13 = annotation.types[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
            var _type14 = _step13.value;

            var result = maybeTupleAnnotation(_type14);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError13 = true;
          _iteratorError13 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion13 && _iterator13.return) {
              _iterator13.return();
            }
          } finally {
            if (_didIteratorError13) {
              throw _iteratorError13;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          return null;
        }
      case 'GenericTypeAnnotation':
      case 'AnyTypeAnnotation':
      case 'ArrayTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        return null;
      default:
        return false;
    }
  }

  function humanReadableType(annotation) {
    var _generate$code;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return humanReadableType(annotation.typeAnnotation);

      case 'FunctionTypeAnnotation':
        // @fixme babel doesn't seem to like generating FunctionTypeAnnotations yet
        return '(' + annotation.params.map(humanReadableType).join(', ') + ') => ' + humanReadableType(annotation.returnType);
      default:
        {
          _generate$code = (0, _babelGenerator2.default)(annotation).code;

          if (typeof _generate$code === 'string') {
            return _generate$code;
          } else {
            throw new TypeError('Function "humanReadableType" return value violates contract, expected string got ' + (_generate$code === null ? 'null' : (typeof _generate$code === 'undefined' ? 'undefined' : _typeof(_generate$code)) === 'object' && _generate$code.constructor ? _generate$code.constructor.name || '[Unknown Object]' : typeof _generate$code === 'undefined' ? 'undefined' : _typeof(_generate$code)));
          }
        }

    }
  }

  function humanReadableObject(annotation, scope) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    if (annotation.properties.length === 0) {
      return 'an object';
    } else {
      var shape = (0, _babelGenerator2.default)(annotation).code;
      return 'an object with shape ' + shape;
    }
  }

  function humanReadableArray(annotation, scope) {
    var _generate$code2;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    _generate$code2 = (0, _babelGenerator2.default)(annotation).code;

    if (typeof _generate$code2 === 'string') {
      return _generate$code2;
    } else {
      throw new TypeError('Function "humanReadableArray" return value violates contract, expected string got ' + (_generate$code2 === null ? 'null' : (typeof _generate$code2 === 'undefined' ? 'undefined' : _typeof(_generate$code2)) === 'object' && _generate$code2.constructor ? _generate$code2.constructor.name || '[Unknown Object]' : typeof _generate$code2 === 'undefined' ? 'undefined' : _typeof(_generate$code2)));
    }
  }

  function humanReadableTuple(annotation, scope) {
    var _generate$code3;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    _generate$code3 = (0, _babelGenerator2.default)(annotation).code;

    if (typeof _generate$code3 === 'string') {
      return _generate$code3;
    } else {
      throw new TypeError('Function "humanReadableTuple" return value violates contract, expected string got ' + (_generate$code3 === null ? 'null' : (typeof _generate$code3 === 'undefined' ? 'undefined' : _typeof(_generate$code3)) === 'object' && _generate$code3.constructor ? _generate$code3.constructor.name || '[Unknown Object]' : typeof _generate$code3 === 'undefined' ? 'undefined' : _typeof(_generate$code3)));
    }
  }

  function isTypeChecker(id, scope) {
    if (!(Identifier(id) || QualifiedTypeIdentifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected Identifier | QualifiedTypeIdentifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    var binding = scope.getBinding(id.name);
    if (binding === undefined) {
      return false;
    }
    var path = binding.path;

    return path != null && (path.type === 'TypeAlias' || path.type === 'ImportSpecifier' || path.type === 'VariableDeclaration' && path.node.isTypeChecker);
  }

  function isPolymorphicType(id, scope) {
    if (!(Identifier(id) || QualifiedTypeIdentifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected Identifier | QualifiedTypeIdentifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    var binding = scope.getBinding(id.name);
    if (binding !== undefined) {
      return false;
    }
    var path = scope.path;

    while (path && path.type !== 'Program') {
      var _path = path;
      var node = _path.node;

      if (t.isFunction(node) && node.typeParameters) {
        var _iteratorNormalCompletion14 = true;
        var _didIteratorError14 = false;
        var _iteratorError14 = undefined;

        try {
          for (var _iterator14 = node.typeParameters.params[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
            var param = _step14.value;

            param.isPolymorphicType = true;
            if (param.name === id.name) {
              return true;
            }
          }
        } catch (err) {
          _didIteratorError14 = true;
          _iteratorError14 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion14 && _iterator14.return) {
              _iterator14.return();
            }
          } finally {
            if (_didIteratorError14) {
              throw _iteratorError14;
            }
          }
        }
      }
      path = path.parent;
    }
    return false;
  }

  function getPolymorphicType(id, scope) {
    if (!(Identifier(id) || QualifiedTypeIdentifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected Identifier | QualifiedTypeIdentifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    var binding = scope.getBinding(id.name);
    if (binding !== undefined) {
      return false;
    }
    var path = scope.path;

    while (path && path.type !== 'Program') {
      var _path2 = path;
      var node = _path2.node;

      if (t.isFunction(node) && node.typeParameters) {
        var _iteratorNormalCompletion15 = true;
        var _didIteratorError15 = false;
        var _iteratorError15 = undefined;

        try {
          for (var _iterator15 = node.typeParameters.params[Symbol.iterator](), _step15; !(_iteratorNormalCompletion15 = (_step15 = _iterator15.next()).done); _iteratorNormalCompletion15 = true) {
            var param = _step15.value;

            param.isPolymorphicType = true;
            if (param.name === id.name) {
              return param;
            }
          }
        } catch (err) {
          _didIteratorError15 = true;
          _iteratorError15 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion15 && _iterator15.return) {
              _iterator15.return();
            }
          } finally {
            if (_didIteratorError15) {
              throw _iteratorError15;
            }
          }
        }
      }
      path = path.parent;
    }
    return null;
  }

  function collectParamChecks(path) {
    var _path$get$map$filter;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    _path$get$map$filter = path.get('params').map(function (param) {
      var node = param.node;

      if (node.type === 'AssignmentPattern') {
        if (node.left.typeAnnotation) {
          return createDefaultParamGuard(param);
        }
      } else if (node.type === 'RestElement') {
        if (node.typeAnnotation) {
          return createRestParamGuard(param);
        }
      } else if (node.typeAnnotation) {
        return createParamGuard(param);
      }
    }).filter(identity);

    if (Array.isArray(_path$get$map$filter) && _path$get$map$filter.every(function (item) {
      return Node(item);
    })) {
      return _path$get$map$filter;
    } else {
      throw new TypeError('Function "collectParamChecks" return value violates contract, expected Array<Node> got ' + (_path$get$map$filter === null ? 'null' : (typeof _path$get$map$filter === 'undefined' ? 'undefined' : _typeof(_path$get$map$filter)) === 'object' && _path$get$map$filter.constructor ? _path$get$map$filter.constructor.name || '[Unknown Object]' : typeof _path$get$map$filter === 'undefined' ? 'undefined' : _typeof(_path$get$map$filter)));
    }
  }

  function createParamGuard(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;

    node.hasBeenTypeChecked = true;
    node.savedTypeAnnotation = node.typeAnnotation;
    var check = checkAnnotation(node, node.typeAnnotation, scope);
    if (!check) {
      return;
    }
    if (node.optional) {
      check = t.logicalExpression('||', checks.undefined({ input: node }).expression, check);
    }
    var message = paramTypeErrorMessage(node, scope);
    return guard({
      check: check,
      message: message
    });
  }

  /**
   * Get any constant violations before a given node.
   * @fixme this is a copy of the internal babel api and relies on a private method.
   */
  function getConstantViolationsBefore(binding, path, functions) {
    var violations = binding.constantViolations.slice();
    violations.unshift(binding.path);
    return violations.filter(function (violation) {
      violation = violation.resolve();
      var status = violation._guessExecutionStatusRelativeTo(path);
      if (functions && status === "function") {
        functions.push(violation);
      }
      return status === "before";
    });
  }

  function createDefaultParamGuard(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.left;
    var value = node.right;

    var ok = staticCheckAnnotation(path.get('right'), id.typeAnnotation);
    if (ok === false) {
      throw path.buildCodeFrameError('Invalid default value for argument "' + id.name + '", expected ' + humanReadableType(id.typeAnnotation, scope) + '.');
    }
    return createParamGuard(path.get('left'));
  }

  function createRestParamGuard(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.argument;

    id.hasBeenTypeChecked = true;
    node.savedTypeAnnotation = node.typeAnnotation;
    if (!isStrictlyArrayAnnotation(node.typeAnnotation)) {
      throw path.buildCodeFrameError('Invalid type annotation for rest argument "' + id.name + '", expected an Array, got: ' + humanReadableType(node.typeAnnotation, scope) + '.');
    }
    var check = checkAnnotation(id, node.typeAnnotation, scope);
    if (!check) {
      return;
    }
    if (node.optional) {
      check = t.logicalExpression('||', checks.undefined({ input: id }).expression, check);
    }
    var message = paramTypeErrorMessage(id, scope, node.typeAnnotation);
    return guard({
      check: check,
      message: message
    });
  }

  function returnTypeErrorMessage(path, fn, id) {
    var _t$binaryExpression;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (!Node(fn)) {
      throw new TypeError('Value of argument "fn" violates contract, expected Node got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    var node = path.node;
    var scope = path.scope;

    var name = fn.id ? fn.id.name : '';
    var message = 'Function ' + (name ? '"' + name + '" ' : '') + 'return value violates contract, expected ' + humanReadableType(fn.returnType, scope) + ' got ';

    _t$binaryExpression = t.binaryExpression('+', t.stringLiteral(message), node.argument ? readableName({ input: id || node.argument }).expression : t.stringLiteral('undefined'));

    if (Node(_t$binaryExpression)) {
      return _t$binaryExpression;
    } else {
      throw new TypeError('Function "returnTypeErrorMessage" return value violates contract, expected Node got ' + (_t$binaryExpression === null ? 'null' : (typeof _t$binaryExpression === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression)) === 'object' && _t$binaryExpression.constructor ? _t$binaryExpression.constructor.name || '[Unknown Object]' : typeof _t$binaryExpression === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression)));
    }
  }

  function paramTypeErrorMessage(node, scope) {
    var _t$binaryExpression2;

    var typeAnnotation = arguments.length <= 2 || arguments[2] === undefined ? node.typeAnnotation : arguments[2];

    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    if (!TypeAnnotation(typeAnnotation)) {
      throw new TypeError('Value of argument "typeAnnotation" violates contract, expected TypeAnnotation got ' + (typeAnnotation === null ? 'null' : (typeof typeAnnotation === 'undefined' ? 'undefined' : _typeof(typeAnnotation)) === 'object' && typeAnnotation.constructor ? typeAnnotation.constructor.name || '[Unknown Object]' : typeof typeAnnotation === 'undefined' ? 'undefined' : _typeof(typeAnnotation)));
    }

    var name = node.name;
    var message = 'Value of ' + (node.optional ? 'optional ' : '') + 'argument "' + name + '" violates contract, expected ' + humanReadableType(typeAnnotation, scope) + ' got ';

    _t$binaryExpression2 = t.binaryExpression('+', t.stringLiteral(message), readableName({ input: node }).expression);

    if (Node(_t$binaryExpression2)) {
      return _t$binaryExpression2;
    } else {
      throw new TypeError('Function "paramTypeErrorMessage" return value violates contract, expected Node got ' + (_t$binaryExpression2 === null ? 'null' : (typeof _t$binaryExpression2 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression2)) === 'object' && _t$binaryExpression2.constructor ? _t$binaryExpression2.constructor.name || '[Unknown Object]' : typeof _t$binaryExpression2 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression2)));
    }
  }

  function varTypeErrorMessage(node, scope, annotation) {
    var _t$binaryExpression3;

    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    if (!(annotation === undefined || TypeAnnotation(annotation))) {
      throw new TypeError('Value of optional argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    var name = node.name;
    var message = 'Value of variable "' + name + '" violates contract, expected ' + humanReadableType(annotation || node.typeAnnotation, scope) + ' got ';
    _t$binaryExpression3 = t.binaryExpression('+', t.stringLiteral(message), readableName({ input: node }).expression);

    if (Node(_t$binaryExpression3)) {
      return _t$binaryExpression3;
    } else {
      throw new TypeError('Function "varTypeErrorMessage" return value violates contract, expected Node got ' + (_t$binaryExpression3 === null ? 'null' : (typeof _t$binaryExpression3 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression3)) === 'object' && _t$binaryExpression3.constructor ? _t$binaryExpression3.constructor.name || '[Unknown Object]' : typeof _t$binaryExpression3 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression3)));
    }
  }

  /**
   * Determine whether the given node can produce purely boolean results.
   */
  function isBooleanExpression(node) {
    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node.type === 'BinaryExpression' && BOOLEAN_BINARY_OPERATORS.indexOf(node.operator) > -1) {
      return true;
    } else if (node.type === 'LogicalExpression') {
      return isBooleanExpression(node.left) && isBooleanExpression(node.right);
    } else {
      return false;
    }
  }

  /**
   * Convert type specifier to expression.
   */
  function createTypeExpression(node) {
    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node.type == 'Identifier') {
      if (node instanceof Object) {
        return node;
      } else {
        throw new TypeError('Function "createTypeExpression" return value violates contract, expected Object got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
      }
    } else if (node.type == 'QualifiedTypeIdentifier') {
      var _t$memberExpression;

      _t$memberExpression = t.memberExpression(createTypeExpression(node.qualification), createTypeExpression(node.id));

      if (_t$memberExpression instanceof Object) {
        return _t$memberExpression;
      } else {
        throw new TypeError('Function "createTypeExpression" return value violates contract, expected Object got ' + (_t$memberExpression === null ? 'null' : (typeof _t$memberExpression === 'undefined' ? 'undefined' : _typeof(_t$memberExpression)) === 'object' && _t$memberExpression.constructor ? _t$memberExpression.constructor.name || '[Unknown Object]' : typeof _t$memberExpression === 'undefined' ? 'undefined' : _typeof(_t$memberExpression)));
      }
    }

    throw this.errorWithNode('Unsupported type: ' + node.type);
  }

  /**
   * Get name of a type as a string.
   */
  function getTypeName(node) {
    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node.type == 'Identifier') {
      var _node$name;

      _node$name = node.name;

      if (typeof _node$name === 'string') {
        return _node$name;
      } else {
        throw new TypeError('Function "getTypeName" return value violates contract, expected string got ' + (_node$name === null ? 'null' : (typeof _node$name === 'undefined' ? 'undefined' : _typeof(_node$name)) === 'object' && _node$name.constructor ? _node$name.constructor.name || '[Unknown Object]' : typeof _node$name === 'undefined' ? 'undefined' : _typeof(_node$name)));
      }
    } else if (node.type == 'QualifiedTypeIdentifier') {
      var _ref71;

      _ref71 = getTypeName(node.qualification) + '.' + getTypeName(node.id);

      if (typeof _ref71 === 'string') {
        return _ref71;
      } else {
        throw new TypeError('Function "getTypeName" return value violates contract, expected string got ' + (_ref71 === null ? 'null' : (typeof _ref71 === 'undefined' ? 'undefined' : _typeof(_ref71)) === 'object' && _ref71.constructor ? _ref71.constructor.name || '[Unknown Object]' : typeof _ref71 === 'undefined' ? 'undefined' : _typeof(_ref71)));
      }
    }

    throw this.errorWithNode('Unsupported type: ' + node.type);
  }

  /**
   * Union two arrays.
   */
  function union(arr1, arr2) {
    if (!Array.isArray(arr1)) {
      throw new TypeError('Value of argument "arr1" violates contract, expected Array got ' + (arr1 === null ? 'null' : (typeof arr1 === 'undefined' ? 'undefined' : _typeof(arr1)) === 'object' && arr1.constructor ? arr1.constructor.name || '[Unknown Object]' : typeof arr1 === 'undefined' ? 'undefined' : _typeof(arr1)));
    }

    if (!Array.isArray(arr2)) {
      throw new TypeError('Value of argument "arr2" violates contract, expected Array got ' + (arr2 === null ? 'null' : (typeof arr2 === 'undefined' ? 'undefined' : _typeof(arr2)) === 'object' && arr2.constructor ? arr2.constructor.name || '[Unknown Object]' : typeof arr2 === 'undefined' ? 'undefined' : _typeof(arr2)));
    }

    for (var i = 0; i < arr2.length; i++) {
      var item = arr2[i];
      if (arr1.indexOf(item) === -1) {
        arr1.push(item);
      }
    }
    return arr1;
  }

  /**
   * Determine whether the given annotation allows any value.
   */
  function allowsAny(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (annotation.type === 'TypeAnnotation' || annotation.type === 'NullableTypeAnnotation') {
      return allowsAny(annotation.typeAnnotation);
    } else if (annotation.type === 'AnyTypeAnnotation' || annotation.type === 'MixedTypeAnnotation') {
      return true;
    } else if (annotation.type === 'UnionTypeAnnotation') {
      var _annotation$types$som;

      _annotation$types$som = annotation.types.some(allowsAny);

      if (typeof _annotation$types$som === 'boolean') {
        return _annotation$types$som;
      } else {
        throw new TypeError('Function "allowsAny" return value violates contract, expected bool got ' + (_annotation$types$som === null ? 'null' : (typeof _annotation$types$som === 'undefined' ? 'undefined' : _typeof(_annotation$types$som)) === 'object' && _annotation$types$som.constructor ? _annotation$types$som.constructor.name || '[Unknown Object]' : typeof _annotation$types$som === 'undefined' ? 'undefined' : _typeof(_annotation$types$som)));
      }
    } else {
      return false;
    }
  }

  /**
   * Determine whether a given node is nully (null or undefined).
   */
  function isNodeNully(node) {
    if (node == null) {
      return true;
    } else if (node.type === 'Identifier' && node.name === 'undefined') {
      return true;
    } else if (node.type === 'Literal' && node.value === null) {
      return true;
    } else if (node.type === 'UnaryExpression' && node.operator === 'void') {
      return true;
    } else {
      return false;
    }
  }

  /**
   * A function that returns its first argument, useful when filtering.
   */
  function identity(input) {
    return input;
  }
};

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var Node = function Node(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string';
};

var Identifier = function Identifier(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && typeof input.name === 'string';
};

var QualifiedTypeIdentifier = function QualifiedTypeIdentifier(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && Identifier(input.id) && (Identifier(input.qualification) || QualifiedTypeIdentifier(input.qualification));
};

var TypeAnnotation = function TypeAnnotation(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string';
};

var Scope = function Scope(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object';
};

var NodePath = function NodePath(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && Node(input.node) && Scope(input.scope);
};

/**
 * # Typecheck Transformer
 */